diff --git a/src/base/core/int.c b/src/base/core/int.c
index a59f45c1e1..ba406399b7 100644
--- a/src/base/core/int.c
+++ b/src/base/core/int.c
@@ -1922,7 +1922,7 @@ static int int19(void)
 }
 
 uint16_t RedirectDevice(char *dStr, char *sStr,
-                        uint8_t deviceType, uint16_t deviceParameter)
+                        uint8_t deviceType, uint16_t deviceOptions)
 {
   uint16_t ret;
 
@@ -1933,8 +1933,8 @@ uint16_t RedirectDevice(char *dStr, char *sStr,
   LWORD(esi) = DOSEMU_LMHEAP_OFFS_OF(dStr);
   SREG(es) = DOSEMU_LMHEAP_SEG;
   LWORD(edi) = DOSEMU_LMHEAP_OFFS_OF(sStr);
-  LWORD(ecx) = 0;
-  LWORD(edx) = deviceParameter;
+  LWORD(edx) = deviceOptions;
+  LWORD(ecx) = REDIR_CLIENT_SIGNATURE;
   LWORD(ebx) = deviceType;
   LWORD(eax) = DOS_REDIRECT_DEVICE;
 
diff --git a/src/dosext/builtins/builtins.c b/src/dosext/builtins/builtins.c
index 11830497e0..71c2cf4c83 100644
--- a/src/dosext/builtins/builtins.c
+++ b/src/dosext/builtins/builtins.c
@@ -438,17 +438,18 @@ uint16_t com_CancelRedirection(char *deviceStr)
  *    (ex. 'TIM\TOOLS')
  *  deviceType indicates the type of device which was redirected
  *    3 = printer, 4 = disk
- *  deviceParameter has my rights to this resource
+ *  deviceUserData has the magic word passed during creation
+ *  deviceOptions has Dosemu specifics (disabled, cdrom unit, read only)
  * NOTES:
  *
  ********************************************/
 uint16_t com_GetRedirection(uint16_t redirIndex, char *deviceStr,
-                            char *slashedResourceStr,
-                            uint8_t *deviceType, uint16_t *deviceParameter)
+                            char *resourceStr, uint8_t *deviceType,
+                            uint16_t *deviceUserData, uint16_t *deviceOptions)
 {
   char *dStr = lowmem_heap_alloc(16);
   char *sStr = lowmem_heap_alloc(128);
-  uint16_t ret, deviceParameterTemp;
+  uint16_t ret, deviceUserDataTemp, deviceOptionsTemp;
   uint8_t deviceTypeTemp;
 
   pre_msdos();
@@ -458,6 +459,7 @@ uint16_t com_GetRedirection(uint16_t redirIndex, char *deviceStr,
   SREG(es) = DOSEMU_LMHEAP_SEG;
   LWORD(edi) = DOSEMU_LMHEAP_OFFS_OF(sStr);
 
+  LWORD(ecx) = REDIR_CLIENT_SIGNATURE;
   LWORD(ebx) = redirIndex;
   LWORD(eax) = DOS_GET_REDIRECTION;
 
@@ -466,16 +468,25 @@ uint16_t com_GetRedirection(uint16_t redirIndex, char *deviceStr,
   ret = (LWORD(eflags) & CF) ? LWORD(eax) : CC_SUCCESS;
 
   deviceTypeTemp = LO(bx);
-  deviceParameterTemp = LWORD(edx);
+  deviceUserDataTemp = LWORD(ecx);
+  deviceOptionsTemp = LWORD(edx);
 
   post_msdos();
 
   if (ret == CC_SUCCESS) {
-    /* copy back unslashed portion of resource string */
-    strcpy(slashedResourceStr, sStr);
+    strcpy(resourceStr, sStr);
     strcpy(deviceStr, dStr);
-    *deviceType = deviceTypeTemp;
-    *deviceParameter = deviceParameterTemp;
+
+    if (deviceType)
+      *deviceType = deviceTypeTemp;
+    if (deviceUserData)
+      *deviceUserData = deviceUserDataTemp;
+    if (deviceOptions) {
+      if (strncmp(sStr, LINUX_RESOURCE, strlen(LINUX_RESOURCE)) == 0)
+        *deviceOptions = deviceOptionsTemp;
+      else
+        *deviceOptions = 0;
+    }
   }
 
   lowmem_heap_free(sStr);
diff --git a/src/dosext/builtins/builtins.h b/src/dosext/builtins/builtins.h
index 1838041087..2eca8ddc44 100644
--- a/src/dosext/builtins/builtins.h
+++ b/src/dosext/builtins/builtins.h
@@ -73,7 +73,7 @@ struct vm86_regs regpack_to_regs(struct REGPACK *regpack);
 int com_FindFreeDrive(void);
 uint16_t com_RedirectDevice(char *, char *, uint8_t, uint16_t);
 uint16_t com_CancelRedirection(char *);
-uint16_t com_GetRedirection(uint16_t, char *, char *, uint8_t *, uint16_t *);
+uint16_t com_GetRedirection(uint16_t, char *, char *, uint8_t *, uint16_t *, uint16_t *);
 
 extern int com_errno;
 
diff --git a/src/dosext/builtins/lredir.c b/src/dosext/builtins/lredir.c
index 6e1cf8a1da..248615ae7c 100644
--- a/src/dosext/builtins/lredir.c
+++ b/src/dosext/builtins/lredir.c
@@ -71,8 +71,6 @@
 #define MAX_RESOURCE_PATH_LENGTH   128  /* added to support Linux paths */
 #define MAX_DEVICE_STRING_LENGTH     5  /* enough for printer strings */
 
-#define READ_ONLY_DRIVE_ATTRIBUTE 1  /* same as NetWare Lite */
-
 #define KEYWORD_DEL   "DELETE"
 #define KEYWORD_DEL_COMPARE_LENGTH  3
 
@@ -145,14 +143,14 @@ static int get_unix_cwd(char *buf)
  * ShowMyRedirections
  *  show my current drive redirections
  * NOTES:
- *  I show the read-only attribute for each drive
- *    which is returned in deviceParam.
+ *  I show the read-only attribute, cdrom unit number
+ *  and disabled state for each drive
  *************************************/
 static void
 ShowMyRedirections(void)
 {
     int driveCount;
-    uint16_t redirIndex, deviceParam, ccode;
+    uint16_t redirIndex, deviceOptions;
     uint8_t deviceType;
     char deviceStr[MAX_DEVICE_STRING_LENGTH];
     char resourceStr[MAX_RESOURCE_PATH_LENGTH];
@@ -160,8 +158,8 @@ ShowMyRedirections(void)
     redirIndex = 0;
     driveCount = 0;
 
-    while ((ccode = com_GetRedirection(redirIndex, deviceStr, resourceStr,
-                           &deviceType, &deviceParam)) == CC_SUCCESS) {
+    while (com_GetRedirection(redirIndex, deviceStr, resourceStr,
+                              &deviceType, NULL, &deviceOptions) == CC_SUCCESS) {
       /* only print disk redirections here */
       if (deviceType == REDIR_DISK_TYPE) {
         if (driveCount == 0) {
@@ -170,14 +168,18 @@ ShowMyRedirections(void)
         driveCount++;
         printf("%-2s = %-20s ", deviceStr, resourceStr);
 
-        /* read attribute is returned in the device parameter */
+        /* read attribute is returned in the device options */
         printf("attrib = ");
-        if (deviceParam > 1)
-          printf("CDROM:%i, ", deviceParam >> 1);
-        if (deviceParam & READ_ONLY_DRIVE_ATTRIBUTE)
+        if (deviceOptions & 0b01110)
+          printf("CDROM:%i, ", (deviceOptions & 0b01110) >> 1);
+        if (deviceOptions & REDIR_DEVICE_READ_ONLY)
           printf("READ ONLY");
         else
           printf("READ/WRITE");
+
+        if (deviceOptions & REDIR_DEVICE_DISABLED)
+          printf(", DISABLED");
+
         printf("\n");
       }
 
@@ -212,15 +214,14 @@ static int DeleteDriveRedirection(char *deviceStr)
 
 static int FindRedirectionByDevice(char *deviceStr, char *presourceStr)
 {
-    uint16_t redirIndex = 0, deviceParam, ccode;
-    uint8_t deviceType;
+    uint16_t redirIndex = 0, ccode;
     char dStr[MAX_DEVICE_STRING_LENGTH];
     char dStrSrc[MAX_DEVICE_STRING_LENGTH];
 
     snprintf(dStrSrc, MAX_DEVICE_STRING_LENGTH, "%s", deviceStr);
     strupperDOS(dStrSrc);
     while ((ccode = com_GetRedirection(redirIndex, dStr, presourceStr,
-                           &deviceType, &deviceParam)) == CC_SUCCESS) {
+                                       NULL, NULL, NULL)) == CC_SUCCESS) {
       if (strcmp(dStrSrc, dStr) == 0)
         break;
       redirIndex++;
@@ -407,24 +408,20 @@ static int fill_dev_str(char *deviceStr, char *argv,
 static int do_redirect(char *deviceStr, char *resourceStr,
 	const struct lredir_opts *opts)
 {
-    uint16_t ccode;
-    int deviceParam = 0;
+    uint16_t ccode, deviceOptions = 0;
 
     if (opts->ro)
-	deviceParam += READ_ONLY_DRIVE_ATTRIBUTE;
+      deviceOptions += REDIR_DEVICE_READ_ONLY;
     if (opts->cdrom)
-	deviceParam += opts->cdrom << 1;
+      deviceOptions += opts->cdrom << 1;
 
     /* upper-case both strings */
     strupperDOS(deviceStr);
     strupperDOS(resourceStr);
 
     /* now actually redirect the drive */
-    ccode = com_RedirectDevice(deviceStr, resourceStr, REDIR_DISK_TYPE,
-                           (uint16_t)deviceParam);
-
-    /* duplicate redirection: try to reredirect */
-    if (ccode == 0x55) {
+    ccode = com_RedirectDevice(deviceStr, resourceStr, REDIR_DISK_TYPE, deviceOptions);
+    if (ccode == 0x55) {     /* duplicate redirection: try to reredirect */
       if (!opts->force) {
         printf("Error: drive %s already redirected.\n"
                "       Use -d to delete the redirection or -f to force.\n",
@@ -432,8 +429,7 @@ static int do_redirect(char *deviceStr, char *resourceStr,
         return 1;
       } else {
         DeleteDriveRedirection(deviceStr);
-        ccode = com_RedirectDevice(deviceStr, resourceStr, REDIR_DISK_TYPE,
-                             (uint16_t)deviceParam);
+        ccode = com_RedirectDevice(deviceStr, resourceStr, REDIR_DISK_TYPE, deviceOptions);
       }
     }
 
@@ -444,10 +440,10 @@ static int do_redirect(char *deviceStr, char *resourceStr,
     }
 
     printf("%s = %s", deviceStr, resourceStr);
-    if (deviceParam > 1)
-      printf(" CDROM:%d", deviceParam >> 1);
+    if (deviceOptions & 0b01110)
+      printf(" CDROM:%d", (deviceOptions & 0b01110) >> 1);
     printf(" attrib = ");
-    if (deviceParam & READ_ONLY_DRIVE_ATTRIBUTE)
+    if (deviceOptions & REDIR_DEVICE_READ_ONLY)
       printf("READ ONLY\n");
     else
       printf("READ/WRITE\n");
diff --git a/src/dosext/mfs/mfs.c b/src/dosext/mfs/mfs.c
index f9d8dc06b4..a7202b038f 100644
--- a/src/dosext/mfs/mfs.c
+++ b/src/dosext/mfs/mfs.c
@@ -1030,7 +1030,7 @@ init_drive(int dd, char *path, int user, int options)
     drives[dd].root = strdup(path);
     drives[dd].root_len = strlen(path);
     drives[dd].user_param = user;
-    drives[dd].options = options;
+    drives[dd].options = (user == REDIR_CLIENT_SIGNATURE) ? options : 0;
     drives[dd].curpath[0] = '\0';
     return 1;
   }
@@ -1076,7 +1076,7 @@ init_drive(int dd, char *path, int user, int options)
   drives[dd].root_len = new_len;
   if (num_drives <= dd)
     num_drives = dd + 1;
-  drives[dd].options = options;
+  drives[dd].options = (user == REDIR_CLIENT_SIGNATURE) ? options : 0;
   drives[dd].curpath[0] = 'A' + dd;
   drives[dd].curpath[1] = ':';
   drives[dd].curpath[2] = '\\';
@@ -2516,6 +2516,7 @@ static int GetRedirection(struct vm86_regs *state)
   char *resourceName;
   char *deviceName;
   u_short *userStack;
+  cds_t tcds;
 
   /* Set number of redirected drives to 0 prior to getting new count */
   /* BH has device status 0=valid */
@@ -2545,10 +2546,22 @@ static int GetRedirection(struct vm86_regs *state)
         /* set the high bit of the return CL so that */
         /* NetWare shell doesn't get confused */
         returnCX = drives[dd].user_param | 0x80;
-        returnDX = drives[dd].options;
-
         Debug0((dbg_fd, "GetRedirection CX=%04x\n", returnCX));
 
+        /* This is a Dosemu specific field, but RBIL states it is usually
+           destroyed by a redirector, so we may use it to pass our info */
+        returnDX = drives[dd].options;
+        /* see if DOS believes drive is redirected */
+        if (!GetCDSInDOS(dd, &tcds)) {
+          Debug0((dbg_fd, "GetRedirection: can't get CDS\n"));
+        } else {
+          if ((cds_flags(tcds) & (CDS_FLAG_READY | CDS_FLAG_REMOTE)) != (CDS_FLAG_READY | CDS_FLAG_REMOTE))
+            returnDX |= REDIR_DEVICE_DISABLED;
+          Debug0((dbg_fd, "GetRedirection: CDS flags are 0x%04x (%s)\n",
+                 cds_flags(tcds), cds_flags_to_str(cds_flags(tcds))));
+        }
+        Debug0((dbg_fd, "GetRedirection DX=%04x\n", returnDX));
+
         userStack = (u_short *)sda_user_stack(sda);
         userStack[1] = returnBX;
         userStack[2] = returnCX;
@@ -2646,20 +2659,29 @@ static int RedirectDisk(struct vm86_regs *state, int drive, char *resourceName)
   return TRUE;
 }
 
-static int RedirectPrinter(char *resourceName, int user)
+static int RedirectPrinter(struct vm86_regs *state, char *resourceName)
 {
-    int drive;
-    char *p;
-    if (strncmp(resourceName, LINUX_PRN_RESOURCE,
-             strlen(LINUX_PRN_RESOURCE)) != 0)
-      return FALSE;
-    p = resourceName + strlen(LINUX_PRN_RESOURCE);
-    if (p[0] != '\\' || !isdigit(p[1]))
-      return FALSE;
-    drive = PRINTER_BASE_DRIVE + toupperDOS(p[1]) - '0' - 1;
-    if (init_drive(drive, p + 1, user, 0) == 0)
-      return (FALSE);
-    return TRUE;
+  uint16_t user = LO_WORD(state->ecx);
+  int drive;
+  char *p;
+
+  if (user == REDIR_CLIENT_SIGNATURE && state->edx & 7) {
+    Debug0((dbg_fd, "Readonly printer redirection\n"));
+    return FALSE;
+  }
+
+  if (strncmp(resourceName, LINUX_PRN_RESOURCE, strlen(LINUX_PRN_RESOURCE)) != 0)
+    return FALSE;
+
+  p = resourceName + strlen(LINUX_PRN_RESOURCE);
+  if (p[0] != '\\' || !isdigit(p[1]))
+    return FALSE;
+
+  drive = PRINTER_BASE_DRIVE + toupperDOS(p[1]) - '0' - 1;
+  if (init_drive(drive, p + 1, user, 0) == 0)
+    return FALSE;
+
+  return TRUE;
 }
 
 /*****************************
@@ -2681,11 +2703,7 @@ static int DoRedirectDevice(struct vm86_regs *state)
 
   Debug0((dbg_fd, "RedirectDevice %s to %s\n", deviceName, resourceName));
   if (LOW(state->ebx) == REDIR_PRINTER_TYPE) {
-    if (state->ecx & 7) {
-      Debug0((dbg_fd, "Readonly printer redirection\n"));
-      return FALSE;
-    }
-    return RedirectPrinter(resourceName, LO_WORD(state->ecx));
+    return RedirectPrinter(state, resourceName);
   }
 
   if (strncmp(resourceName, LINUX_RESOURCE, strlen(LINUX_RESOURCE)) != 0) {
diff --git a/src/include/redirect.h b/src/include/redirect.h
index 1f23bb7e8e..354fe17da2 100644
--- a/src/include/redirect.h
+++ b/src/include/redirect.h
@@ -25,6 +25,10 @@
 
 #define REDIR_PRINTER_TYPE    3
 #define REDIR_DISK_TYPE       4
+#define REDIR_CLIENT_SIGNATURE 0x5544             /* 'DU' */
+#define REDIR_DEVICE_READ_ONLY 0b0000000000000001 /* Same as NetWare Lite */
+                            /* 0b0000000000001110    CDROM unit number */
+#define REDIR_DEVICE_DISABLED  0b1000000000000000
 
 #define DOS_GET_REDIRECTION    0x5F02
 #define DOS_REDIRECT_DEVICE    0x5F03
